# Grabber for break.com
#
# (c) 2007 by Ralf Ertzinger <ralf@camperquake.de>
# licensed under GNU GPL v2

package videosite::BreakGrabber;

use videosite::GrabberBase;
@ISA = qw(videosite::GrabberBase);

use videosite::HTMLHelper;
use Data::Dumper;

use strict;

sub new {
    my $class = shift;
    my $self = $class->SUPER::new(
        NAME => 'break',
        PATTERNS => ['(http://(?:[-a-zA-Z0-9_.]+\.)*break.com/index/([-a-zA-Z0-9_]+?)\.html)'],
        @_,
    );

    return bless($self, $class);
}

sub _parse {
    my $self = shift;
    my $url = shift;
    my $pattern = shift;
    my $content;
    my $metadata = {};
    my $p = videosite::HTMLHelper->new();
    my $n;

    $url =~ m|$pattern|;
    $url = $1;

    $metadata->{'URL'} = $url;
    $metadata->{'ID'} = $2;
    $metadata->{'TYPE'} = 'video';
    $metadata->{'SOURCE'} = $self->{'NAME'};
    $metadata->{'TITLE'} = undef;
    $metadata->{'DLURL'} = undef;

    unless(defined($content = $p->load($1))) {
        $self->error('Could not download %s', $url);
        return undef;
    }

    $n = $p->findnodes('meta[@name="embed_video_title"]');
    if (defined($n)) {
        $metadata->{'TITLE'} = $n->{'content'};
    }

    $n = $p->findnodes('meta[@name="embed_video_thumb_url"]');
    if (defined($n)) {
        $metadata->{'DLURL'} = $n->{'content'};
        $metadata->{'DLURL'} =~ s/\.jpg$/\.flv/;
    }

    unless(defined($metadata->{'DLURL'}) && defined($metadata->{'TITLE'})) {
        $self->error('Could not determine download URL');
        return undef;
    }

    return $metadata;
}

1;
